// QANav Report Tracker Copyright 2008 Ronald D. Grindle

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.qanavigation.Basics.Rslt;
import com.qanavigation.QNservices.QNDBacc2;
import com.qanavigation.QNservices.SrvltReqTools;

/**
* Service interface level calls to report test execution
*/
public class Ajax extends HttpServlet {
	
	static final long serialVersionUID = 61940015;

	//---------------------------------------------
	protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		super.service( request, response );
	}

	//---------------------------------------------
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {
		handleReq( request, response );
	}

	//---------------------------------------------
	public void doPost(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {
		handleReq( request, response );
	}

	//---------------------------------------------
	public void handleReq(HttpServletRequest request, HttpServletResponse response) throws IOException {

		boolean notHandled = true;

		String msg1 = "";
		
		response.setContentType("text/xml");

		PrintWriter out = response.getWriter();

		//QNRscBundle resBndl = new QNRscBundle( "QNLabels", request.getLocale() );

		Rslt res = new Rslt( true );
		
		QNDBacc2 dBAcc = new QNDBacc2();

		SrvltReqTools sTools = new SrvltReqTools( this, request );
		
		if( !res.checkRslt( sTools ) ) {
			
			res.addRsltAddInfo( "Init of SrvltReqTools failed." );
		}

		if( res.isOK() ) {

notHandled = false;
msg1 = "<response><val>Message received.</val></response>";
msg1 = "{\"response\":{\"vals\": [\"Message1\",\"Message2\"]}}";
//RsltString val = sTools.getVal( "QNA" );
//msg1 += "</p><p>YourRequest: '" + val.getString() + "'";

			// manage request -----------------------------------------
			// example from User Mgmt
			if( sTools.checkVal( "QNA", "Test" ) ) {
/*
				User = sTools.getVal( "User" );
				
				if( res.checkRslt( User ) ) {
					
					PW = sTools.getVal( "PW" );
				}
	*/			
				if( res.notOK() ) {
					
					res.addRsltAddInfo( "'Add User': Retrieving a parameter failed." );
				}
				else {
					
					// do something

				}

			}



			// unknown request -----------------------------------------
			if( notHandled ) {

				msg1 = "Unknown request.";
			}
		}

		if( res.isOK() ) {

			out.println( "<p>" + msg1 + "</p>" );
		}
		
		dBAcc.close();
	}
}
