// QANav Report Tracker Copyright 2008 -2009 Ronald D. Grindle

package RTObj;

import java.util.ArrayList;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;

import RTtools.RTDataList;
import RTtools.UserRoleTool;

import com.qanavigation.Basics.RsltLst;
import com.qanavigation.Basics.RsltTable;
import com.qanavigation.QNservices.QNDBacc2;
import com.qanavigation.QNservices.QNDefs;
import com.qanavigation.QNservices.UserTool;

/**
 * Base Object; User Roles, User Lists
 * @author RGDM2
 *
 */
public class RTtoolsObj extends RTIFObj {
	
	public boolean m_roleIsSrvc;
	
	public String m_mode;
	public String m_yGroup;
	
	public UserTool m_uTool;
	public UserRoleTool m_uRTool;

	/**
	 * 
	 * @param p_Request
	 * @param p_dBAcc
	 */
	public RTtoolsObj( HttpServlet p_Srvl, HttpServletRequest p_Request, QNDBacc2 p_dBAcc ) {
		
		super( p_Srvl, p_Request, p_dBAcc );
		
		initMe( p_Request );
		
		if( notOK() ) {
			
			addRsltAddFailInfo( "RTtoolsObj", "RTtoolsObj", "", "" );
		}
	}
	
	// -------------------------
	private void initMe( HttpServletRequest p_Request ) {
		
		m_roleIsSrvc = false;
		
		m_yGroup = "";
		
		m_uTool = new UserTool( m_dBAcc.m_DB );
		m_uRTool = new UserRoleTool( p_Request, m_xDB );
		
		m_yGroup = m_uTool.getGroupForUser( m_User );
		
		m_mode = m_sTools.getStrVal( "Mode" );
	}
	
	/**
	 * 
	 * @return All registered Applications
	 */
	public ArrayList<String> getApplLstOpts() {
		
		ArrayList<String> outLst = new ArrayList<String>();
		
		int i, x;
		
		RsltTable rTbl;
		
		String val;

		rTbl = m_uTool.getApplLst();

		if( rTbl.isOK() ) {

			x = rTbl.size();

			for( i = 0; i < x; ++i ) {
			
				val = rTbl.getCell( 0, i );
				outLst.add( "<option value=\"" + val + "\">" + val + "</option>"  );				
			}
		}	
		
		return outLst;
	}
	
	/**
	 * Delivers "<option value=\"" + val + "\">" + val + "</option>".
	 * @return
	 */
	public ArrayList<String> getApplOpts4User() {
		
		ArrayList<String> outLst = new ArrayList<String>();
		
		int i, x;
		
		RsltTable rTbl;
		
		String val;
		
		String[] colNames = {"Prod"};
		
		String tableName = "UserProds";
		String appx = "WHERE Name = '" + m_User + "'";

		rTbl = m_dBAcc.m_DB.select( tableName, colNames, appx );

		if( rTbl.isOK() ) {
				
			x = rTbl.size();
		
			for( i = 0; i < x; ++i ) {
	
				val = rTbl.getCell( 0, i );
				outLst.add( "<option value=\"" + val + "\">" + val + "</option>"  );	
			}
		}
		
		return outLst;
	}		
	
	/**
	 * 
	 * @return The list of BA
	 */
	public ArrayList<String> getBALstOpts() {
		
		ArrayList<String> outLst = new ArrayList<String>();
		
		int i, x;
		
		RsltTable rTbl;
		
		String val;

		rTbl = m_uTool.getUserLst( QNDefs.c_RoleBA );

		if( rTbl.isOK() ) {

			x = rTbl.size();

			for( i = 0; i < x; ++i ) {
			
				val = rTbl.getCell( 0, i );
				outLst.add( "<option value=\"" + val + "\">" + val + "</option>"  );				
			}
		}
		
		return outLst;
	}
	
// ######### Branch TCom ######	
	/**
	 * 
	 * @return Only the values
	 */
	public ArrayList<String> getBranchLst() {
		
		ArrayList<String> outLst = new ArrayList<String>();
		
		int i, x;
		
		RsltTable rTbl;
		
		String val;
		
		String[] colNames = {"Val"};
		
		String tableName = "DataLst";
		String appx = " WHERE Name = 'DevBranch'";

		rTbl = m_dBAcc.m_DB.select( tableName, colNames, appx );

		if( rTbl.isOK() ) {
				
			x = rTbl.size();
		
			for( i = 0; i < x; ++i ) {
	
				val = rTbl.getCell( 0, i );
				outLst.add( val );	
			}
		}		
		
		return outLst;
	}	
		
//	######### Branch TCom End ######	
	
	/**
	 * 
	 * @return
	 */
	public ArrayList<String> getCRExtSourceOpts() {
		
		return getDataLstAsOpts( "CRExtSource.lst" );
	}
	
	/**
	 * 
	 * @return
	 */
	public ArrayList<String> getCRExtStatOpts() {
		
		return getDataLstAsOpts( "CRExtStat.lst" );
	}	
	
	/**
	 * 
	 * @return
	 */
	public ArrayList<String> getCRTypeOpts() {
		
		return getDataLstAsOpts( "CRType.lst" );
	}
	
	/**
	 * 
	 * @param p_DataLstName
	 * @return
	 */
	public ArrayList<String> getDataLstAsOpts( String p_DataLstName ) {
		
		ArrayList<String> outLst = new ArrayList<String>();
		ArrayList<String> lst;
		
		int i, x;
		
		RTDataList rdl = new RTDataList( m_Request );
		
    	lst = rdl.getLst( p_DataLstName );
    	
    	x = lst.size();
    	
    	for( i = 0; i < x; ++i ) {
	    		
    		outLst.add( "<option value=\"" + lst.get( i ) + "\">" + lst.get( i ) + "</option>"  );
    	}    	
		
		return outLst;
	}
	
	/**
	 * 
	 * @return The list of Dev
	 */
	public ArrayList<String> getDevLstOpts() {
		
		ArrayList<String> outLst = new ArrayList<String>();
		
		int i, x;
		
		RsltTable rTbl;
		
		String val;

		rTbl = m_uTool.getUserLst( QNDefs.c_RoleDev );

		if( rTbl.isOK() ) {

			x = rTbl.size();

			for( i = 0; i < x; ++i ) {
			
				val = rTbl.getCell( 0, i );
				outLst.add( "<option value=\"" + val + "\">" + val + "</option>"  );				
			}
		}
		
		return outLst;
	}	

	/**
	 * 
	 * @return
	 */
	public ArrayList<String> getExtTRSrcOpts() {
		
		return getDataLstAsOpts( "ExtTRSrc.lst" );
	}
	
		
	public ArrayList<String> getFixSectionsOpts(  ) {
		
		return getPropLstAsOpts( "FixSections.lst" );
	}
	
	/**
	 * 
	 * @param p_DataLstName
	 * @return
	 */
	public ArrayList<String> getPropLstAsOpts( String p_DataLstName ) {
		
		ArrayList<String> outLst = new ArrayList<String>();
		RsltLst<String[]> lst;
		
		String[] row;
		
		int i, x;
		
		RTDataList rdl = new RTDataList( m_Request );
		
    	lst = rdl.getPropLst( p_DataLstName );
    	
    	x = lst.size();
    	
    	for( i = 0; i < x; ++i ) {
    		
    		row = lst.get( i );
	    		
    		outLst.add( "<option value=\"" + row[0] + "\">" + row[1] + "</option>"  );
    	}    	
		
		return outLst;
	}	
	
	/**
	 * 
	 * @param p_Group
	 * @return
	 */
	public ArrayList<String> getSrvcLstOpts( String p_Group ) {
		
		ArrayList<String> outLst = new ArrayList<String>();
		
		int i, x;
		
		RsltTable rTbl;
		
		String val;

		rTbl = m_uTool.getSrvcLst( p_Group );

		if( rTbl.isOK() ) {

			x = rTbl.size();

			for( i = 0; i < x; ++i ) {
			
				val = rTbl.getCell( 0, i );
				outLst.add( "<option value=\"" + val + "\">" + val + "</option>"  );				
			}
		}
		
		return outLst;
	}
	
	/**
	 * 
	 * @return
	 */
	public ArrayList<String> getUGroupLstOpts() {
		
		ArrayList<String> outLst = new ArrayList<String>();
		
		int i, x;
		
		RsltTable rTbl;
		
		String val;

		rTbl = m_uTool.getUGroupLst();

		if( rTbl.isOK() ) {

			x = rTbl.size();

			for( i = 0; i < x; ++i ) {
			
				val = rTbl.getCell( 0, i );
				outLst.add( "<option value=\"" + val + "\">" + val + "</option>"  );				
			}
		}	
		
		return outLst;
	}
	
	/**
	 * 
	 * @return
	 */
	public ArrayList<String> getUserLstOpts() {
		
		ArrayList<String> outLst = new ArrayList<String>();
		
		int i, x;
		
		RsltTable rTbl;
		
		String val;

		rTbl = m_uTool.getUserLst();

		if( rTbl.isOK() ) {

			x = rTbl.size();

			for( i = 0; i < x; ++i ) {
			
				val = rTbl.getCell( 0, i );
				outLst.add( "<option value=\"" + val + "\">" + val + "</option>"  );				
			}
		}			
		
		return outLst;
	}
	
	/**
	 * Delivers "<option value=\"" + val + "\">" + val + "</option>".
	 * @return
	 */
	public ArrayList<String> getSysOpts() {
		
		ArrayList<String> outLst = new ArrayList<String>();
		
		int i, x;
		
		RsltTable rTbl;
		
		String val;
		
		String[] colNames = {"Name"};
		
		String tableName = "Systems";
		String appx = " ORDER BY BINARY Name";

		rTbl = m_dBAcc.m_DB.select( tableName, colNames, appx );

		if( rTbl.isOK() ) {
				
			x = rTbl.size();
		
			for( i = 0; i < x; ++i ) {
	
				val = rTbl.getCell( 0, i );
				
				outLst.add( "<option value=\"" + val + "\">" + val + "</option>"  );	
			}
		}
		
		return outLst;
	}	
}
