// QANav Report Tracker Copyright 2008 -2009 Ronald D. Grindle

package RTObj;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;

import sun.security.action.GetLongAction;

import com.qanavigation.QNservices.QNDBacc2;

/**
 * Technical Report List Base Object
 * @author RGDM2
 *
 */
public class TRLstObj extends RTLstLstObj {
	
	public boolean m_modeIsSLS = false;
	
	public boolean m_roleIsTRSup = false;
	public boolean m_roleIsTRSrvc = false;
	
	// -------------------------
	public TRLstObj( HttpServlet p_Srvl, HttpServletRequest p_Request, QNDBacc2 p_dBAcc ) {
		
		super( p_Srvl, p_Request, p_dBAcc );
		
		initMe();
		
		if( notOK() ) {
			
			addRsltAddFailInfo( "TRLstObj", "TRLstObj", "", "" );
		}
	}
	
	// -------------------------
	private void initMe() {
	
		m_modeIsSLS = false;
		
		m_roleIsTRSup = m_uRTool.isTRSuper();
		m_roleIsTRSrvc = m_uRTool.isTRSrvc();
		m_roleIsSrvc = m_roleIsTRSrvc;
		
		if( m_mode.compareTo( "SLS" ) == 0 ) {
			
			m_modeIsAll = true;
			m_modeIsSLS = true;
			m_modeIsWoCl = true;
			m_withAssign = "false";
			m_srtMode = "aUp";
		}	
	}
	
	// --------------------------
	public void  prepare() {
		
		prepParam( "Appl", "", "false" );
		prepParam( "Assignd", "", "false" );
		prepParam( "Author", "", "false" );
		prepParam( "CRNum", "CmpCRNum", "true" );
		prepParam( "DateTime", "CmpDateTime", "false" );
		prepParam( "ExtID", "CmpExtID", "false" );
		//prepParam( "Fctn", "CmpFctn", "false" );			
		prepParam( "IsCR", "", "false" );
		//prepParam( "Prio", "", "false" );
		prepParam( "ProbClass", "", "false" );
		prepParam( "ProbStat", "", "false" );
		prepParam( "PSource", "", "false" );
		prepParam( "SoftRel", "CmpSoftRel", "false" );
		prepParam( "Ticket", "CmpTicket", "true" );
		prepParam( "Title", "CmpTitle", "false" );				
		
		if( m_roleIsTRSrvc ) {
			
			if( m_modeIsAll ) {
			
				m_assGroup = "";
			}
			else {
	
				if( !( m_roleIsTRSup ) ) { 
	
					m_uGroup = m_yGroup;
				}
			}
		}
		else {
	
			m_paramMap.put( "Author", m_User );
			m_strRO = " readonly";
		}		
	}
}
