// QANav Report Tracker Copyright 2008 -2009 Ronald D. Grindle
package RTObj;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;

import RTtools.UserMailTool;

import com.qanavigation.Basics.Rslt;
import com.qanavigation.Basics.RsltString;
import com.qanavigation.Basics.SFormatter;
import com.qanavigation.QNservices.QNDBacc2;
import com.qanavigation.QNservices.QNDefs;

/**
 * Technical Report Base Object
 * @author RGDM2
 *
 */
public class TRRepObj extends RTRepObj {
	
	public TRRepBld m_trb;
	
	/**
	 * 
	 * @param p_Request
	 * @param p_dBAcc
	 */
	public TRRepObj( HttpServlet p_Srvl, HttpServletRequest p_Request, QNDBacc2 p_dBAcc ) {

		super( p_Srvl, p_Request, p_dBAcc );
		
		m_trb = new TRRepBld( m_xDB, m_sTools, QNDefs.c_RMFilePath );
		
		checkRslt( m_trb );
		
		super.init( m_trb, "EditTR.jsp" );
		
		m_roleIsSrvc = m_uRTool.isTRSrvc();
		
		if( notOK() ) {
			
			addRsltAddFailInfo( "TRRepObj", "TRRepObj", "", "" );
		}		
	}
	
	// ------------
	protected RsltString handleSave( boolean isDraft, boolean isSub ) {

		Rslt res;
		
		RsltString rVal;
		RsltString rUID = new RsltString( "" );
		
		String sUID;

		res = m_trb.bldProbRep( isDraft, isSub );
		
//m_sTools.logMsg( this.getClass().getName() + "handleSave(): isSub " + isSub + ", isDraft " + isDraft );		
		
		if( rUID.checkRslt( res ) ) {

			rUID = m_trb.save2DB( m_User, isDraft, true );
			
//m_sTools.logMsg( this.getClass().getName() + "UID '" + rUID.getString() + "'" );

			if( rUID.isOK() && isSub ) {
				
				sUID = rUID.getString();				
				
				//String title = m_resBndl.getString( "lblNewDoc" );
				//String txt = m_resBndl.getString( "msgNewDoc" );
				//m_trb.addLogX( m_UID.getString(), m_User, title, txt, "", "" );					
				
				String txt = SFormatter.format( m_resBndl.getString( "msgNewDocBy" ), m_User );
				res = m_trb.appProcLogX( sUID, txt );
				
//m_sTools.logMsg( this.getClass().getCanonicalName() + ": appProcLogX " + txt );				
				
				rVal = m_trb.getAssignee( sUID );
				
				res.setRsltStat( rVal );
				
				m_sTools.logIfErr( res );
				
				txt = SFormatter.format( m_resBndl.getString( "msgRepAssgnTo" ), rVal.getString() );
				res.setRsltStat( m_trb.appProcLogX( sUID, txt ) );
				
//m_sTools.logMsg( this.getClass().getCanonicalName() + ": getAssignee " + rVal.getString() );			
//m_sTools.logMsg( this.getClass().getCanonicalName() + ": appProcLogX " + txt );
				
				res.setRsltStat( issueMail4NewDoc( rVal.getString() ) );
				
				m_sTools.logIfErr( res );

				//out.println( "<script type=\"text/javascript\">notify( \"ProbIssOK\" );</script>" );			
			}
		}

		if( rUID.notOK() ) {
			
			rUID.addRsltAddFailInfo( "TRRepObj", "handleSave", "", "IsDraft: " + isDraft + ", IsSub: " + isSub );
		}
		
		m_sTools.logIfErr( rUID );
		
		return rUID;
	}	
	
	/**
	 * 
	 * @return
	 */
	protected Rslt issueMail4NewDoc( String p_Assgn ) {
		
		Rslt res;
		
		UserMailTool mt = new UserMailTool( m_dBAcc.m_DB );
		
		String repTitle = m_sTools.getStrVal( "Title" );
		String ticketNum = m_trb.getTicket();

		//String lnk = "RepIss.jsp?QNA=EditIss&UID=" + UID.getString();
		
		String theUrl = m_sTools.getUrl4DocView( m_UID.getString(), QNDefs.c_QNAViewTR );

		String sender = m_resBndl.getString( "valSenderMail" );	
		String senderClear = m_resBndl.getString( "valSenderClear" );

		String mSubj = SFormatter.format( m_resBndl.getString( "lblNewProbRep" ), ticketNum );

		String mMsg = "<p>" + mSubj + ":</p>";
		mMsg += "<p><a href=\"" + theUrl + "\">" + ticketNum + " " + repTitle + "</a></p>";

		String pMsg = mSubj;
		pMsg += "\n" + theUrl + " (" + repTitle + ")";

		res = mt.mailToAssgn( p_Assgn, mSubj, pMsg, mMsg, sender, senderClear );
		
		return res;
	}
}
