// QANav Report Tracker Copyright 2009 Ronald D. Grindle

package RTtools;

import java.util.ArrayList;

import com.qanavigation.Basics.IRslt;
import com.qanavigation.Basics.Rslt;
import com.qanavigation.Basics.RsltStatVal;
import com.qanavigation.QNservices.QNDocManSrvc;

/**
 * Template for external hooks.
 * Extend the code to customize to your requirements, but leave all methods intact.
 *
 */
public class ExtCallHooks {

	private QNDocManSrvc m_docSrvc;
	
	public ExtCallHooks( QNDocManSrvc p_docSrvc) {
		
		m_docSrvc = p_docSrvc;
		
		/* Place your initialization code here */
	}
	
	/**
	 * Is called when the status of a document changes.
	 * p_addVal may be filled with additional information for a specific state.
	 * @param p_UID
	 * @param p_docType
	 * @param p_statVal
	 * @param p_addVal
	 */
	void statChg( String p_UID, String p_statVal, String p_addVal ) {
		
		Rslt res = new Rslt( true );
		
		try {
			
			// System.out.println( "statChg: '" + p_UID + "' '" + p_statVal + "' '" + p_addVal + "'" );					
		}
		catch( Exception excp ) {
			
			res.setRsltByExcp( excp );
		}

		if( res.notOK() ) {
			
			res.addRsltAddInfo( "ExtCallHooks.statChg()" );
		}
		
		issueIfErrors( res );
	}
	
	
    // -------------------------------------------
    public void issueIfErrors( IRslt res ) {

    	int i, x;

    	if( res.notOK() ) {
    		
    		ArrayList<String> addInfo;    		
           
    		issueLine( "ExtCallHooks: execution failed." );
                   
    		addInfo = res.getRsltAddInfo();
   
    		issueLine( "Error Messages:" );
   
    		x = addInfo.size();
   
    		for( i = 0; i < x; ++i ) {
   
    			issueLine( (String)addInfo.get( i ) );
    		}
                   
    		issueLine( "Status: " + RsltStatVal.label[ res.getRsltStatVal() ] );
   
    	}
    }
    
    // -------------------------------------------    
    public void issueLine( String p_msg ) {
    	
    	System.out.println( p_msg );    	
    }
}
