/*
* Copyright 2004 The Apache Software Foundation
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/
/* $Id: HelloWorldExample.java,v 1.3 2004/03/18 16:40:33 jfarcand Exp $
 *
 */

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Enumeration;

import javax.servlet.ServletException;
import javax.servlet.ServletInputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


public class TstSrvl extends HttpServlet {
	
		static final long serialVersionUID = 61940008;

		private String s;

		protected void service(HttpServletRequest request, HttpServletResponse response)
				            throws ServletException, IOException
		{
			s = "Service;";
/*
			BufferedReader in = request.getReader();
			s += " ready: " + in.ready();

			while( (line = in.readLine()) != null ) {

				s += line;
			}
*/
			super.service( request, response );
		}


    public void doGet(HttpServletRequest request,
                      HttpServletResponse response)
        throws IOException, ServletException
    {

			String line;

			s += " doGet;";

        /*ResourceBundle rb =
            ResourceBundle.getBundle("LocalStrings", request.getLocale());*/
        response.setContentType("text/html");
        PrintWriter out = response.getWriter();

        out.println("<html>");
        out.println("<head>");

//	    String title = rb.getString("helloworld.title");
				    String title = "Servlet Test";

		out.println("<title>" + title + "</title>");
        out.println("</head>");
        out.println("<body bgcolor=\"white\">");

	// note that all links are created to be relative. this
	// ensures that we can move the web application that this
	// servlet belongs to to a different place in the url
	// tree and not have any harmful side effects.

        // XXX
        // making these absolute till we work out the
        // addition of a PathInfo issue


        out.println("<h1>" + title + "</h1>");

//			out.println( "<p>'" + i + "'</p>" );
		out.println( "<p>'" + s + "'</p>" );		

line = request.getQueryString();

out.println( "<p>'" + line + "'</p>" );

        out.println("</body>");
        out.println("</html>");
    }

		
    public void doPost(HttpServletRequest request,
                      HttpServletResponse response)
        throws IOException, ServletException
    {

			String line;

			s += " doPost;";

        /*ResourceBundle rb =
            ResourceBundle.getBundle("LocalStrings", request.getLocale());*/
        response.setContentType("text/html");
        PrintWriter out = response.getWriter();

        out.println("<html>");
        out.println("<head>");

//	    String title = rb.getString("helloworld.title");
				    String title = "Servlet Test(Post)";

		    out.println("<title>" + title + "</title>");
        out.println("</head>");
        out.println("<body bgcolor=\"white\">");

	// note that all links are created to be relative. this
	// ensures that we can move the web application that this
	// servlet belongs to to a different place in the url
	// tree and not have any harmful side effects.

        // XXX
        // making these absolute till we work out the
        // addition of a PathInfo issue


        out.println("<h1>" + title + "</h1>");

//			out.println( "<p>'" + i + "'</p>" );
		out.println( "<p>'" + s + "'</p>" );
		

line = request.getQueryString();

out.println( "<p>Query: '" + line + "'</p>" );

String name;
String type1 = request.getHeader("Content-Type");
String len = request.getHeader("Content-Length");
String type2 = request.getContentType();
int len2 = request.getContentLength();
Enumeration hNames = request.getHeaderNames();
Enumeration hVals;

out.println("<pre>");

do {
	
	name = hNames.nextElement().toString();
	out.println( name );
	
	hVals = request.getHeaders( name );
	
	while( hVals.hasMoreElements() ) {
		
		out.println( "- " + hVals.nextElement() );		
	}
} while( hNames.hasMoreElements() );

out.println("</pre>");

out.println( "<p>Type1: '" + type1 + "'</p>" );
out.println( "<p>Type2: '" + type2 + "'</p>" );
out.println( "<p>Len: '" + len + "'</p>" );
out.println( "<p>Len: '" + len2 + "'</p>" );

out.println( "<p>data</p>" );

out.println("<pre>");

byte[] buf = new byte[80];

int c;

ServletInputStream sis = request.getInputStream();

do {

	c = sis.readLine( buf, 0, 80 );
	
	//out.print( c );
	
	if( c > 0 ) {
	
		line = "'";
		
		line += new String( buf, 0, (c-2) );
		
		line += "'";
		
		out.println( line );
		
		//out.println( "'" );
	}

} while( c > 0 );

out.println("");

out.println("</pre>");
out.println( "<p>data end</p>" );

        out.println("</body>");
        out.println("</html>");
    }
}



