// QANav Report Tracker Copyright 2004 Ronald D. Grindle

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Locale;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import RTtools.UserMailTool;

import com.qanavigation.Basics.Rslt;
import com.qanavigation.Basics.RsltStatVal;
import com.qanavigation.Basics.RsltString;
import com.qanavigation.Basics.SFormatter;
import com.qanavigation.QNservices.QNDBacc2;
import com.qanavigation.QNservices.QNDefs;
import com.qanavigation.QNservices.QNDoc;
import com.qanavigation.QNservices.QNRscBundle;
import com.qanavigation.QNservices.QNxDBbridge;
import com.qanavigation.QNservices.SrvltReqTools;

/**
 * Report Tracker Viewer.
 * @author RDG
 *
 */
public class VQANavDoc extends HttpServlet {
	
	static final long serialVersionUID = 61940001;

	//---------------------------------------------
	protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		super.service( request, response );
	}

	//---------------------------------------------
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {
		handleReq( request, response );
	}

	//---------------------------------------------
	public void doPost(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {
		handleReq( request, response );
	}

	//---------------------------------------------
	public void handleReq(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {

		boolean notHandled = true;
		
		int p1, p2;
		
		String XslName = "";
		String MsgAllOK = "";
		String name;
		
		String QNA = "";
		
		RsltString rUID;
		RsltString rName;
		
		response.setContentType("text/html");
		
		PrintWriter out = response.getWriter();
					
		Locale loc = request.getLocale();

		//ResourceBundle resBndl = ResourceBundle.getBundle( "QNLabels", loc );
		QNRscBundle resBndl = new QNRscBundle( "QNLabels", request.getLocale() );
		
		Rslt res = new Rslt( true );
		
		QNDBacc2 dBAcc = new QNDBacc2();
		QNxDBbridge xDBB = new QNxDBbridge( dBAcc.m_DB );

		SrvltReqTools sTools = new SrvltReqTools( this, request );
		
		QNA = sTools.getStrVal( "QNA" );
		
		rUID = sTools.getVal( "UID" );
		
		QNDoc qnDoc = new QNDoc( dBAcc.m_DB, rUID.getString() );
		
		if( QNA.compareTo( "ViewDoc" ) == 0 ) {
			
			//notHandled = false;
			
			if( res.checkRslt( rUID ) ) {

				rName = xDBB.m_xDB.getNodeName( rUID.getString() );
				
				if( res.checkRslt( rName ) ) {
					
					name = rName.getString();
					
					if( name.compareTo( QNDefs.c_NodeCmpgn ) == 0 ) {
						
						QNA = "ViewCmpgn";
					}
					else if( name.compareTo( QNDefs.c_NodeCRReport ) == 0 ) {
						
						QNA = QNDefs.c_QNAViewCR;
					}
					else if( name.compareTo( QNDefs.c_NodeFix ) == 0 ) {
						
						QNA = "ViewFix";
					}
					else if( name.compareTo( QNDefs.c_NodeIssReport ) == 0 ) {
						
						QNA = QNDefs.c_QNAViewIss;
					}
					else if( name.compareTo( QNDefs.c_NodeTechReport ) == 0 ) {
						
						QNA = QNDefs.c_QNAViewTR;
					}
					else if( name.compareTo( QNDefs.c_NodeShpDoc ) == 0 ) {
						
						QNA = QNDefs.c_QNAViewShp;
					}
					else if( name.compareTo( QNDefs.c_NodeTC ) == 0 ) {
						
						QNA = "ViewTC";
					}			
					else if( name.compareTo( QNDefs.c_NodeTCExec ) == 0 ) {
						
						QNA = "ViewTCEx";
					}					
					else if( name.compareTo( QNDefs.c_NodeTCSet ) == 0 ) {
						
						QNA = "ViewTCS";
					}									
				}
			}
		}
				
		if( notHandled ) {
			if( QNA.compareTo( "ViewCmpgn" ) == 0 ) {
				
				notHandled = false;
	
				XslName = "QN.CmpgnDocV01";
				MsgAllOK = "VCmpgnOK";
			}
		}
		
		if( notHandled ) {
			if( QNA.compareTo( QNDefs.c_QNAViewCR ) == 0 ) {

				qnDoc.updateTRRef();
				
				notHandled = false;
	
				XslName = "QN.CRRepV01";
				MsgAllOK = "VCROK";
			}
		}		

		if( notHandled ) {
			if( QNA.compareTo( "ViewFix" ) == 0 ) {
				
				notHandled = false;
	
				XslName = "QN.FixDocV01";
				MsgAllOK = "VFixOK";
			}
		}

		if( notHandled ) {
			if( QNA.compareTo( QNDefs.c_QNAViewIss ) == 0 ) {
				
				notHandled = false;
	
				XslName = "QN.IssRepV01";
				MsgAllOK = "VIssOK";
			}
		}
		
		if( notHandled ) {
			if( QNA.compareTo( QNDefs.c_QNAViewTR ) == 0 ) {
				
				notHandled = false;
				
				XslName = "QN.TechRepV01";
				MsgAllOK = "VProbRepOK";
			}
		}
		
		if( notHandled ) {
			if( QNA.compareTo( QNDefs.c_QNAViewShp ) == 0 ) {
				
				notHandled = false;
				
				XslName = "QN.ShpDocV01";
				MsgAllOK = "VShpDocOK";
			}
		}

		if( notHandled ) {
			if( QNA.compareTo( "ViewTC" ) == 0 ) {
				
				notHandled = false;
	
				XslName = "QN.TestCaseV01";
				MsgAllOK = "VTestCaseOK";
			}
		}
		
		if( notHandled ) {
			if( QNA.compareTo( "ViewTCEx" ) == 0 ) {
				
				notHandled = false;
	
				XslName = "QN.TCExecV01";
				MsgAllOK = "VTCExecOK";
			}
		}
		
		if( notHandled ) {
			if( QNA.compareTo( "ViewTCS" ) == 0 ) {
				
				notHandled = false;
	
				XslName = "QN.TCSetV01";
				MsgAllOK = "VTCSOK";
			}
		}
		
		if( notHandled ) {
			
			res.setInError( resBndl.getString( "errWrongQNAppl" ) );
		}
		else {

			if( res.isOK() ) {

				String XSLTname;
				String lang;
				String pth;

				//= "D:\\Program Files\\Apache Software Foundation\\Tomcat 5.0\\webapps\\piQa\\QN.TechRepV01.xsl";

				lang = loc.getLanguage();

				// did not work with latest Java (Tomcat?) version (?)
				/* */
				pth = request.getSession().getServletContext().getRealPath( "./xsl" );
				//pth = pth.substring( 0, (pth.length() - 1) );
				
				p1 = pth.lastIndexOf( "\\" );
				p2 = pth.lastIndexOf( "/" );

				if( p1 > p2 ) {
					
					pth += "\\";
				}
				else {
				
					pth += "/";
				}
				//out.println( "<p>" + pth + "</p>" );				
				/* */
				
				/* Session Info *
				URL url = request.getSession().getServletContext().getResource("/."); 
				String tpth = "Host " + url.getHost() + ", Path " + url.getPath() + ", Ext " + url.toExternalForm()
				+ ", UserInf " + url.getUserInfo() + ", Port " + url.getPort() 
				+ ", Prot " + url.getProtocol() + ", Q " + url.getQuery() + ", Ref " + url.getRef();
				out.println( "<p>" + tpth + "</p>" );
				* */
				
				/* More Session Info *
				tpth = request.getSession().getServletContext().getContextPath() +
				", " + request.getSession().getServletContext().getServerInfo();
				out.println( "<p>" + tpth + "</p>" );
				* */
		
				/* alternative: by URL
				String uri = request.getRequestURI();
				pth = request.getRequestURL().toString();
				int l = pth.length() - uri.length();
				pth = pth.substring( 0, l );
				pth += ctxtPth + "/";
				out.println( "<p>" + pth + "</p>" );
				*/
				
				/* Problem fix: short path doesn't work on Linux
				String ctxtPth = request.getContextPath();
				//out.println( "<p>" + ctxtPth + "</p>" );
				pth = "webapps" + ctxtPth + "/"; */
			
				XSLTname = pth + XslName + ".xsl";
//out.println( "<p>" + XSLTname + "</p>" );
				
				if( lang.equals( "de" ) ) {

					XSLTname = pth + XslName + "_de.xsl";
				}

				if( lang.equals( "en" ) ) {

					XSLTname = pth + XslName + "_en.xsl";
				}

//out.println( "<p>" + XSLTname + "</p>" );				

				if( res.checkRslt( qnDoc ) ) {
							
					String nodeName = "Script";
					//String val = "function notify( ev ) {if( parent.frames.navF.m_lastStat == undefined ) { window.setTimeout( \"notify('\" + ev + \"')\", 500 );} else { parent.frames.navF.notify( ev );	}} notify( \"VProbRepOK\" );";
					String val = "function notify( ev ) {if( parent.m_ImHere == undefined ) { window.setTimeout( \"notify('\" + ev + \"')\", 500 );} else { parent.notify( ev );	}} notify( \"" + MsgAllOK + "\" );";

					res = qnDoc.injectNode( nodeName, val );
				}

				if( res.isOK() ) {
								
					res = qnDoc.viewXDoc( XSLTname, response );
				} 
			}
		}
		
		if( res.notOK() ) {
		
/*	
int i, x;
out.println( "<p>Status res: " + RsltStatVal.label[ res.getRsltStatVal() ] + "</p>" );
out.println( "<p>UID: " + UID + "</p>" );
ArrayList addInfo;
addInfo = res.getRsltAddInfo();
x = addInfo.size();
for( i = 0; i < x; ++i ) {
	out.println( "<br>" + (String)addInfo.get( i ) );
}	
 */
			UserMailTool mt = new UserMailTool( dBAcc.m_DB );
			String mMsg = "An error occured: " + res.getRsltFinalMsg();
			String subj = "QANav error at " + request.getRequestURL();
			
			String sender = resBndl.getString( "valSenderMail" );	
			String senderClear = resBndl.getString( "valSenderClear" );
			
			mt.mailToAdm( subj, mMsg, mMsg, sender, senderClear );

			String errMsg1 = resBndl.getString( "errTransxFailed" );
			
			String errMsg2; 
			
			if( res.getRsltStatVal() == RsltStatVal.isEmpty ) {
				
				errMsg2 = resBndl.getString( "errDocNotFound" );
			}
			else {
			
				errMsg2 = SFormatter.format( resBndl.getString( "errReason" ), res.getRsltFinalMsg() );	
			}
			
			String errMsg3 = resBndl.getString( "errAdminNotified" );

			SrvltReqTools.logErr( this, request, res );

			ServletContext sc = getServletContext();
			String url = "/ErrMsg.jsp?";

			url += "Msg1=" + SrvltReqTools.encodeReqStr( errMsg1  );
			url += "&Msg2=" + SrvltReqTools.encodeReqStr( errMsg2  );
			url += "&Msg3=" + SrvltReqTools.encodeReqStr( errMsg3  );
			
/*		
out.println( "<p>" + errMsg1 + "</p>" );			
out.println( "<p>" + errMsg2 + "</p>" );
out.println( "<p>" + errMsg3 + "</p>" );
*/

			RequestDispatcher rd = sc.getRequestDispatcher( url );
			
			if( rd != null ) {
				
				rd.forward( request, response );
			}
			else {
				
				out.println( "<p>" + errMsg1 + "</p>" );			
				out.println( "<p>" + errMsg2 + "</p>" );
				out.println( "<p>" + errMsg3 + "</p>" );
			}
		}
		
		dBAcc.close();
	}
}
