
/* These are the values that define the severity of an observation and the
	impact to the overall severity.
	You may change them according to your own politics. */

// Threshold for severity levels.

// The according class is assigned, if the sum of all impact
// values remains below the threshold value.

var m_SevClsThrsh = new Array();
m_SevClsThrsh["C"] = 10; // Anything below is "D"
m_SevClsThrsh["B"] = 100; // Anything below is "C"
m_SevClsThrsh["A"] = 1000; // Anything below is "B"

// Threshhold for Work Arounds
// Unless the calculated value is below this threshold
// the severity of the error is reduced to "B", if 
// the existance of a workaround is indicated.
var m_WAHighThresh = 10000;

// Impact table for the status of the application

var m_ImpApplStat = new Array();
m_ImpApplStat["C"] = 1; // Continues
m_ImpApplStat["I"] = 100; // Inaccessible
m_ImpApplStat["S"] = 100; // Stopped
m_ImpApplStat["R"] = 10000; // Scrambled
m_ImpApplStat["T"] = 100; // Stuck
m_ImpApplStat["X"] = 10000; // Crash
m_ImpApplStat["n"] = 0; // not selected.

// Impact table for the problem ranking

var m_ImpProbCode = new Array();
m_ImpProbCode["I"] = 1; // Ignorable
m_ImpProbCode["A"] = 10; // Annoying
m_ImpProbCode["E"] = 10; // Errorneous
m_ImpProbCode["O"] = 100; // Obstructive
m_ImpProbCode["B"] = 1000; // Blocking
m_ImpProbCode["n"] = 0; // not selected.

// Impact table for the data status

var m_ImpDataStat = new Array();
m_ImpDataStat["M"] = 100; // Minor Data Loss
m_ImpDataStat["L"] = 10000; // Major Data Loss
m_ImpDataStat["N"] = 1; // No Loss Detected
m_ImpDataStat["U"] = 1; // Undecidable
m_ImpDataStat["n"] = 0; // not selected.

// Impact table for the reproducibility status

var m_ImpRepro = new Array();
m_ImpRepro["R"] = 1; // reproducible
m_ImpRepro["X"] = 100; // not reproducible
m_ImpRepro["N"] = 1; // not tested
m_ImpRepro["n"] = 0; // not selected.

// Impact table for the error status

var m_ImpErrStat = new Array();
m_ImpErrStat["E"] = 10; // error issued
m_ImpErrStat["n"] = 0; // not selected.

// Impact table for the "new feature"

var m_ImpNewF = new Array();
m_ImpNewF["F"] = true; // new feature, no error
m_ImpNewF["n"] = false; // not selected, error

// Problems where no error message is issued are lifted to severity class 'B'
// if they are not trivial (class "D")
var m_LiftNoErr = true;

// ------------------------------------------
function calcSevCls( p_ErrStr ) {

	var errCls = 0;
	var sevCnt;

	var subStr;

	var noErr;

	noErr = true;

	sevCnt = 0;
	
	flag = p_ErrStr.charAt(5);
	
	if( m_ImpNewF[ flag ] ) {
	
		sevCnt = 0;
	}
	else {

		// ApplStat
		flag = p_ErrStr.charAt(0);
	
		sevCnt += m_ImpApplStat[ flag ];
	
		// DataStat
		flag = p_ErrStr.charAt(1);
		
		sevCnt += m_ImpDataStat[ flag ];
	
		// Repro
		flag = p_ErrStr.charAt(2);
	
		sevCnt += m_ImpRepro[ flag ];
	
		// ProbCodeBut
		flag = p_ErrStr.charAt(3);
	
		sevCnt += m_ImpProbCode[ flag ];
	
		//ErrStat
		errFlag = p_ErrStr.charAt(4);
	
		sevCnt += m_ImpErrStat[ errFlag ];
	
		// Calculation of "Work Around" ##############################
		flag = p_ErrStr.charAt(5);
	
		switch( flag ) {
	
			case 'W':
	
				/* reduce to B if work around is available and severity is not too high */
				if( ( sevCnt >= (m_SevClsThrsh["A"]) ) && ( sevCnt < m_WAHighThresh ) ) {
	
					sevCnt = m_SevClsThrsh["A"] - 1;
				}
	
			break;
		}
	
		// lift to B if no error is issued ###########################
		/*
		if( m_LiftNoErr && (errFlag != "E") ) {
			if( (sevCnt >= m_SevClsThrsh["C"]) && (sevCnt < m_SevClsThrsh["B"])  ) {
	
				sevCnt = m_SevClsThrsh["B"] + 1; 
			}
		}
		*/
	}
	
	// set the counter
	//document.getElementById("sevLvl").value = sevCnt;

	// evaluate the severity class
	if( sevCnt < m_SevClsThrsh["C"] ) {

		errCls = "4";
	}
	else {

		if( sevCnt < m_SevClsThrsh["B"] ) {

			errCls = "3";
		}
		else {

			if( sevCnt < m_SevClsThrsh["A"] ) {

				errCls = "2";
			}
			else {

				errCls = "1"
			}
		}
	}

	return errCls;
}

// ------------------------------------------
function compProbCode() {

	var probCd;

	probCd = "";

	probCd = getRadioVal( "ApplStat" );
	probCd += getRadioVal( "DataStat" );
	probCd += getRadioVal( "Repro" );
	probCd += getRadioVal( "ProbCodeBut" );
	probCd += getRadioVal( "ErrStat" );
	probCd += getRadioVal( "WorkA" );
	probCd += getRadioVal( "NewF" );
	//probCd += "nn";

	return probCd;
}

// ------------------------------------------
function setNewF( ) {

	var isNewF = getRadioVal( "NewF" );
	
	var setRO = false; 
	
	if( isNewF == "F" ) {
	
		setRO = true;
	}

	setRButRO( "ApplStat", setRO );
	setRButRO( "DataStat", setRO );
	setRButRO( "Repro", setRO );
	setRButRO( "ProbCodeBut", setRO );
	setRButRO( "ErrStat", setRO );
	setRButRO( "WorkA", setRO );
	
	//document.getElementById("ProbCode").value = isNewF;
	
	doProbClsCalc();
}

// ------------------------------------------
function setErrCode() {

	var theChkBox;

	theChkBox = document.getElementsByName( "NewF" );
	theChkBox[0].checked = false;
	
	doProbClsCalc();
}

// ------------------------------------------
function doProbClsCalc() {

	probCd = compProbCode();
	//document.getElementById("probCodeTst").value = probCd;
	document.getElementById("ProbCode").value = probCd;
	
	probCls = calcSevCls( probCd );
	document.getElementById("ProbClass").value = probCls;
	
	document.getElementById("ProbClassLbl").value = probCodes[probCls];
}

