// QANav Report Tracker Copyright 2004 - 2009 Ronald D. Grindle
// V2.0

var SORT_COLUMN_INDEX = 1;

var aTxt;
var m_Tbl;

// --------------------------
function getCellVal( p_Tbl, p_Row, p_Col ) {

	var cells, row, val;
	
	row = p_Tbl.rows[p_Row];

	cells = row.getElementsByTagName( "TD" );

	val = getInText( cells[p_Col] );

	return val;
}

// --------------------------
function getInText( p_Elem ) {
	
	var row;
	var type;
	var val;

	//row = new Array();

	if( typeof p_Elem.childNodes[0] == "undefined" ) {

		type = "#text";
		val = "";
	}
	else {

		type = p_Elem.childNodes[0].nodeName;
		//type = p_Elem.childNodes[0].nodeType;

		if( type == "INPUT" ) {

			val = p_Elem.childNodes[0];
			//val = p_Elem.innerHTML;
		}
		else {

			type = "#text";

			if( MS ) {

				val = p_Elem.innerText
			}
			else {

				val = p_Elem.childNodes[0].nodeValue;
			}
		}
	}

	//row[0] = type;
	//row[1] = val;

	return val;
}

// --------------------------
function reorgTblNew( p_Tbl, p_SrtRows, p_StrtRow, p_StrtCol ) {

	var i, k, x, y;
	var ix;
	var nRow;
	var val;
	var nLst = new Array();
	var ids = new Array();

	x = p_SrtRows.length;

	if( x > 0 ) {
	
		cells = p_Tbl.rows[p_StrtRow].cells;
	
		y = cells.length;	
		
		// scrape the vals
		for( i = 0; i < x; i++ ) { 

			ix = p_SrtRows[i][0] + p_StrtRow;

			nRow = new Array();
			
			for( k = p_StrtCol; k < y; k++ ) {

				nRow[k] = getCellVal( p_Tbl, ix, k );
				//nRow[k] = i + "," + k;
			}

			nLst[i] = nRow;

			ids[i] = p_Tbl.rows[ix].id;
		}

		// fill the list
		for( i = 0; i < x; i++ ) { 

			ix = i + p_StrtRow;

			nRow = nLst[i];
			
			for( k = p_StrtCol; k < y; k++ ) {
			
				val = nRow[k];
			
				//val = i + "," + k;

				setCellVal( p_Tbl, ix, k, val );
			}

			p_Tbl.rows[ix].id = ids[i];
		}
	
	}
}

// --------------------------
function setCellVal( p_Tbl, p_Row, p_Col, p_Val ) {

	var i, x;
	var cl;
	var tn;
	
	row = p_Tbl.rows[p_Row];

	cells = row.getElementsByTagName( "TD" );
	
	cl = cells[p_Col];

	if( MS ) {

		cl.innerText = p_Val;
	}
	else {
	
		if( cl.childNodes.length > 0 ) {

			cl.childNodes[0].nodeValue = p_Val;
		}
		else {

			tn = document.createTextNode( p_Val );
			cl.appendChild( tn );
		}
	}
}

// --------------------------
function sortTbl( p_TblName, p_SrtMode, p_IdxSrtCol, p_StrtRow, p_StrtCol ) {

	var i, x;

//node = document.getElementById( "tst1" );
//setTxt( node, "sort" );
//node.innerHtml = "Sort";

	srtRows = new Array();

	tbl = document.getElementById( p_TblName );

//m_Tbl = tbl

	x = tbl.rows.length - p_StrtRow;

	for( i = 0; i < x; i++ ) { 

		j = i + p_StrtRow;

		srtRow = new Array();

		srtRow[0] = i;
		srtRow[1] = getCellVal( tbl, j, p_IdxSrtCol );

		srtRows[i] = srtRow;
	}

	if( p_SrtMode == "aUp" ) {

		srtRows.sort( sortUp );
	}
	else {

		if( p_SrtMode == "nUp" ) {

			srtRows.sort( numSortUp );
		}
		else {

			if( p_SrtMode == "nDwn" ) {

//alert( "nDwn" );

				srtRows.sort( numSortDown );
			}
			else {

				srtRows.sort( sortDown );
			}
		}
	}

	//appendRows2Tbl( p_TblName, srtRows, p_StrtRow );

	//reorgTbl( tbl, srtRows, p_StrtRow );
	reorgTblNew( tbl, srtRows, p_StrtRow, p_StrtCol );
}

// --------------------------
function sortDown( p_A, p_B ) {

	aVal = p_A[SORT_COLUMN_INDEX].toLowerCase();
	bVal = p_B[SORT_COLUMN_INDEX].toLowerCase();

	if( aVal == bVal ) {
		
		return 0;
	}

	if( aVal < bVal ) {
		
		return -1;
	}
	
	return 1;
}

// --------------------------
function sortUp( p_A, p_B ) {

	aVal = p_A[SORT_COLUMN_INDEX].toLowerCase();
	bVal = p_B[SORT_COLUMN_INDEX].toLowerCase();

	if( aVal == bVal ) {
		
		return 0;
	}

	if( aVal < bVal ) {
		
		return 1;
	}
	
	return -1;
}

// --------------------------
function numSortUp( p_A, p_B ) {

	a = p_A[SORT_COLUMN_INDEX].toLowerCase();
	b = p_B[SORT_COLUMN_INDEX].toLowerCase();

	return( a - b ); 
}
 
// --------------------------
function numSortDown( p_A, p_B ) {

	a = p_A[SORT_COLUMN_INDEX].toLowerCase();
	b = p_B[SORT_COLUMN_INDEX].toLowerCase();

	return( b - a ); 
}

// -------------------------
function trace( p_Tbl, p_Txt ) {

	var ix;
	var nrow, cl;

	ix = p_Tbl.rows.length;

	nrow = p_Tbl.insertRow(ix);
	cl = nrow.insertCell(0);
	cl.setAttribute("colspan", 9, "false" );
	cl.innerHTML = "<p>" + p_Txt + "</p>";
}

// --------------------------
/*
function reorgTbl( p_Tbl, p_SrtRows, p_StrtRow ) {

	var i, k, x, y;
	var ix;
	var row;
	var cells;
	var ccells;
	var cl;
	var nrow;
	var ncells;
	var rows = new Array();

	x = p_SrtRows.length;

	if( x > 0 ) {
	
		cells = p_Tbl.rows[p_StrtRow].cells;
	
		y = cells.length;
	
		/*
		for( i = 0; i < x; i++ ) { 
	
			cells = p_Tbl.rows[i + p_StrtRow].cells;
	
			ncells = new Array();
	
			for( k = 0; k < y; k++ ) {
	
				if( cells[k].childNodes.length > 0 ) {
	
					ncells[k] = cells[k].first.cloneNode( true );
				}
				else {
	
					ncells[k] = null;
				}
			}
	
			rows[i] = ncells;
		}
		* /
	
		
		for( i = 0; i < x; i++ ) { 
	
			ix = p_SrtRows[i][0];
			
			//row = rows[ix];
		
			nrow = p_Tbl.insertRow(i + p_StrtRow);

//trace( p_Tbl, "ix " + (i + p_StrtRow) + " " + (ix + p_StrtRow) );
//trace( p_Tbl, "ix " + p_Tbl.rows[ix + p_StrtRow].id );

			row = p_Tbl.rows[ix + p_StrtRow + i + 1];
	
			setRowAttr( nrow, p_Tbl.rows[ix + p_StrtRow + i + 1] );

		//ccells = rows[ix];
/*
		for( k = 0; k < y; k++ ) {

			cl = nrow.insertCell(k);

			if( ccells[k] != null ) {

				cl.appendChild( ccells[k] );
			}
			else {

//cl.innerHTML += "(null)";
			} * /
			
			cells = row.cells;
			
			for( k = 0; k < y; k++ ) {
	
				cl = nrow.insertCell(k);
	
				cloneCell( cl, cells[k] );
			}
		}
	
		remRows( p_Tbl, p_StrtRow + x);
	}
}
*/

// --------------------
/*
function cloneCell( p_NCell, p_OCell ) {

	var cnode;
	var onc = p_OCell.onclick;

	var cls = p_OCell.getAttribute( "className" );

	p_NCell.setAttribute( "className", cls);
	
	p_NCell.onclick = onc;
	
	if( p_OCell.childNodes.length > 0 ) {
	
		cnode = p_OCell.childNodes[0].cloneNode( true );
	
		p_NCell.appendChild( cnode );
	}
}
*/

// -----------------------------------
/*
function cloneCell( p_NCell, p_OCell ) {

	var onc = p_OCell.onclick;
	
	var val;
	var tn;
	
	if( MS ) {

		val = p_OCell.innerText
	}
	else {
	
		if( p_OCell.childNodes.length > 0 ) {

			val = p_OCell.childNodes[0].nodeValue;
		}
		else {
		
			val = "";
		}
	}

//trace( m_Tbl, "sra " + onc );

	p_NCell.onclick = onc;

	if( MS ) {

		p_NCell.innerText = val;
	}
	else {
	
		tn = document.createTextNode( val );

		p_NCell.appendChild( tn );
	
		//p_NCell.childNodes[0].nodeValue = val;
	}
}
*/

// -----------------------------------
/*
function setRowAttr( p_NRow, p_ORow ) {

		var id = p_ORow.id;
		var omov = p_ORow.onmouseover;
		var omou = p_ORow.onmouseout;
		//var bgcolor = p_ORow.style.backgroundColor;
		var bgc = p_ORow.bgColor;
		var onc = p_ORow.onclick;

//trace( m_Tbl, "sra " + onc );

		p_NRow.id = id;
		p_NRow.onmouseover = omov;
		p_NRow.onmouseout = omou;
		p_NRow.onclick = onc;
		p_NRow.setAttribute("bgcolor", bgc, "false" );

		//p_NRow.addEventListener( "mouseover", omov, true );
		//p_NRow.addEventListener( "mouseout", mOut, true );
}
*/

/* -------------------------
function cloneCell( p_Trgt, p_Src ) {


	if( p_Src.childNodes.length > 0 ) {

		p_Trgt.appendChild( p_Src.firstChild.cloneNode( true ) );
		p_Trgt.innerHTML += "xxx";
	}
	else {

		p_Trgt.innerHTML = "<p>(empty)</p>";
	}
}
*/

/* --------------------------
function replTblRowVals( p_TblName, p_Rows, p_Strt ) {

	var i, x;

	var len;

	var rw;
	var dRow;

	tbl = document.getElementById( p_TblName );

	x = p_Rows.length;

	for( i = 0; i < x; i++ ) { 

		dRow = p_Rows[i];

		rw = tbl.rows[i + p_Strt];

		replRowCellVals( rw, dRow );

//document.writeln( aTxt );
	
//node = document.getElementById( "tst1" );
//setTxt( node, i + p_Strt );
	}
}
*/

/* --------------------------
function replRowCellVals( p_Row, p_DatRow ) {

	var i, x;

	var l;

	var cl;
	var dRow;

	cells = p_Row.getElementsByTagName( "TD" );

	x = cells.length;

	l = p_DatRow.length;

	for( i = 0; i < x; i++ ) { 

		cl = cells[i];

		dRow = p_DatRow[i];

		setCell( cl, dRow );

//aTxt += " '" + dCl + "'";
	}

//aTxt += "<br>";

//node = document.getElementById( "tst3" );
//setTxt( node, p_DatRow[2] );

	p_Row.id = p_DatRow[ l - 1];

//node = document.getElementById( "tst4" );
//setTxt( node, cells[2].data );
}
*/

// --------------------------
/*
function appendRows2Tbl( p_TblName, p_Rows, p_Strt ) {

	var i, x;

	var rw;
	var dRow;

	tbl = document.getElementById( p_TblName );

	x = p_Rows.length;

	for( i = 0; i < x; i++ ) { 

		dRow = p_Rows[i];

		rw = tbl.insertRow( i + p_Strt );

		appendRow2Tbl( rw, dRow );
	}
}
*/

// --------------------------
/*
function appendRow2Tbl( p_Row, p_DatRow ) {

	var i, x;

	var cl;
	var dCl;

	cells = p_Row.getElementsByTagName( "TD" );

	x = cells.length;

	for( i = 0; i < x; i++ ) { 

		cl = p_Row.insertCell( i );

		dCl = p_DatRow[i];

		appendCell2TblRow( cl, dCl );
	}
}
*/

/* --------------------------
function appendCell2TblRow( p_Cell, p_DatVal ) {

	txt = document.createTextNode( p_DatVal );
	p_Cell.appendChild( txt );
}
*/

/* --------------------------
function getTblRowVals( p_Row, p_Strt ) {

	var i, x;
	var val;

	cells = p_Row.getElementsByTagName( "TD" );

	x = cells.length;

	datRow = new Array();

	for( i = 0; i < x; i++ ) {

		val = getInText(cells[i]);

		datRow[i] = val;
	}

	datRow[i] = p_Row.id;

//node = document.getElementById( "tst1" );
//setTxt( node, i + " " + datRow[i] );

	return datRow;
}
*/


// --------------------------
/*
function remRows( p_Tbl, p_Strt ) {

	var i, x;

	x = p_Tbl.rows.length;

//document.writeln( "<br>" + p_Strt + " " + x );

	for( i = p_Strt; i < x; i++ ) { 

		tbl.deleteRow( p_Strt );
//document.writeln( "<br>" + i + " " + x );
	}
}
*/


/* --------------------
function setCell( p_Node, p_Cell ) {

	var tn, cn;

	cn = p_Node.childNodes[0];

	if( p_Cell[0] == "#text" ) {

		val = p_Cell[1];
		tn = document.createTextNode( val );

		if( typeof( cn ) == "undefined" ) {

			p_Node.appendChild( tn );
		}
		else {

			p_Node.replaceChild( tn, cn );	
		}
	}
	else {

		tn = p_Cell[1];
		//tn = document.createTextNode( p_Cell[0] );

		if( typeof( cn ) != "undefined" ) {

			p_Node.removeChild( cn );
		}

		p_Node.appendChild( tn );
	}
}
*/
