<?xml version='1.0'?>
<!-- Stylesheet for a Campaign Document -->

<!DOCTYPE stylesheet [

<!ENTITY nbsp    "&#160;" >
<!ENTITY iexcl   "&#161;" >
<!ENTITY cent    "&#162;" >
<!ENTITY pound   "&#163;" >
<!ENTITY curren  "&#164;" >
<!ENTITY yen     "&#165;" >
<!ENTITY brvbar  "&#166;" >
<!ENTITY sect    "&#167;" >
<!ENTITY uml     "&#168;" >
<!ENTITY copy    "&#169;" >
<!ENTITY ordf    "&#170;" >
<!ENTITY laquo   "&#171;" >
<!ENTITY not     "&#172;" >
<!ENTITY shy     "&#173;" >
<!ENTITY reg     "&#174;" >
<!ENTITY macr    "&#175;" >
<!ENTITY deg     "&#176;" >
<!ENTITY plusmn  "&#177;" >
<!ENTITY sup2    "&#178;" >
<!ENTITY sup3    "&#179;" >
<!ENTITY acute   "&#180;" >
<!ENTITY micro   "&#181;" >
<!ENTITY para    "&#182;" >
<!ENTITY middot  "&#183;" >
<!ENTITY cedil   "&#184;" >
<!ENTITY sup1    "&#185;" >
<!ENTITY ordm    "&#186;" >
<!ENTITY raquo   "&#187;" >
<!ENTITY frac14  "&#188;" >
<!ENTITY frac12  "&#189;" >
<!ENTITY frac34  "&#190;" >
<!ENTITY iquest  "&#191;" >
<!ENTITY Agrave  "&#192;" >
<!ENTITY Aacute  "&#193;" >
<!ENTITY Acirc   "&#194;" >
<!ENTITY Atilde  "&#195;" >
<!ENTITY Auml    "&#196;" >
<!ENTITY Aring   "&#197;" >
<!ENTITY AElig   "&#198;" >
<!ENTITY Ccedil  "&#199;" >
<!ENTITY Egrave  "&#200;" >
<!ENTITY Eacute  "&#201;" >
<!ENTITY Ecirc   "&#202;" >
<!ENTITY Euml    "&#203;" >
<!ENTITY Igrave  "&#204;" >
<!ENTITY Iacute  "&#205;" >
<!ENTITY Icirc   "&#206;" >
<!ENTITY Iuml    "&#207;" >
<!ENTITY ETH     "&#208;" >
<!ENTITY Ntilde  "&#209;" >
<!ENTITY Ograve  "&#210;" >
<!ENTITY Oacute  "&#211;" >
<!ENTITY Ocirc   "&#212;" >
<!ENTITY Otilde  "&#213;" >
<!ENTITY Ouml    "&#214;" >
<!ENTITY times   "&#215;" >
<!ENTITY Oslash  "&#216;" >
<!ENTITY Ugrave  "&#217;" >
<!ENTITY Uacute  "&#218;" >
<!ENTITY Ucirc   "&#219;" >
<!ENTITY Uuml    "&#220;" >
<!ENTITY Yacute  "&#221;" >
<!ENTITY THORN   "&#222;" >
<!ENTITY szlig   "&#223;" >
<!ENTITY agrave  "&#224;" >
<!ENTITY aacute  "&#225;" >
<!ENTITY acirc   "&#226;" >
<!ENTITY atilde  "&#227;" >
<!ENTITY auml    "&#228;" >
<!ENTITY aring   "&#229;" >
<!ENTITY aelig   "&#230;" >
<!ENTITY ccedil  "&#231;" >
<!ENTITY egrave  "&#232;" >
<!ENTITY eacute  "&#233;" >
<!ENTITY ecirc   "&#234;" >
<!ENTITY euml    "&#235;" >
<!ENTITY igrave  "&#236;" >
<!ENTITY iacute  "&#237;" >
<!ENTITY icirc   "&#238;" >
<!ENTITY iuml    "&#239;" >
<!ENTITY eth     "&#240;" >
<!ENTITY ntilde  "&#241;" >
<!ENTITY ograve  "&#242;" >
<!ENTITY oacute  "&#243;" >
<!ENTITY ocirc   "&#244;" >
<!ENTITY otilde  "&#245;" >
<!ENTITY ouml    "&#246;" >
<!ENTITY divide  "&#247;" >
<!ENTITY oslash  "&#248;" >
<!ENTITY ugrave  "&#249;" >
<!ENTITY uacute  "&#250;" >
<!ENTITY ucirc   "&#251;" >
<!ENTITY uuml    "&#252;" >
<!ENTITY yacute  "&#253;" >
<!ENTITY thorn   "&#254;" >
<!ENTITY yuml    "&#255;" >

]>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="html" version="1.0"  indent="yes"/>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="/">

	<html>
	<head>

		<title>
			<xsl:text disable-output-escaping="yes">#%lblQANav%# - #%lblCampaign%# '</xsl:text>
			<xsl:value-of disable-output-escaping="yes" select="Cmpgn/@Title"/>
			<xsl:text disable-output-escaping="yes">'</xsl:text>
		</title>

		<link rel="stylesheet" type="text/css" href="QNXSLStyle.css"/>
		<link href="favicon.ico" rel="shortcut icon"/>

		<xsl:apply-templates select="Cmpgn/Script"/>
	</head>
	<body bgcolor="silver" class="work">
		<xsl:apply-templates select="Cmpgn"/>
	</body>
	</html>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="Script">
	<script type="text/javascript">
	<xsl:value-of disable-output-escaping="yes" select="text()"/>
	</script>
</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="Cmpgn">

	<h2 style="margin-left=6px;">#%lblCampaign%#</h2>

	<table width="95%">
		<tr><td><b>
			<xsl:value-of disable-output-escaping="yes" select="./@Title"/>
		</b></td></tr>
	</table>
	
	<table>
		<tr>
			<td width="120px"><b>#%lblSection%#</b></td>
			<td colspan="3"><xsl:value-of disable-output-escaping="yes" select="./@Section" /></td>
		</tr>
		<tr>
			<td width="120px"><b>#%lblAppl%#</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@Appl" /></td>
			<td width="80px"><b>#%lblRel%#</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@SoftRel" /></td>
		</tr>
		<tr>
			<td width="120px"><b>#%lblFctn%#</b></td>
			<td colspan="3"><xsl:value-of disable-output-escaping="yes" select="./@Fctn" /></td>
		</tr>
	</table>

	<table>
		<tr>
			<td><b>#%lblAuthor%#</b></td>
			<td><b>#%lblDate%#</b></td>
			<td><b>#%lblStatus%#</b></td>
		</tr>
		<tr>
			<td><xsl:value-of disable-output-escaping="yes" select="./@Author" /></td>
			<td><xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/></td>
			<td><xsl:apply-templates select="./@Status"/></td>
		</tr>
	</table>

	<xsl:if test="string(./@Lock)">
		<table><tr><td width="30"><img src="rsc/PadLock.jpg" alt="Locked"/></td></tr></table>
	</xsl:if>

	<xsl:if test="TCSList">

		<xsl:apply-templates select="./TCSList"/>
	</xsl:if>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="@Status">

	<xsl:choose > 
		<xsl:when test = ". = 'ce'" > 
			<xsl:text>#%lblCeased%#</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'cl'" > 
			<xsl:text>#%lblClosed%#</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'ex'" > 
			<xsl:text>#%lblInExec%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'op'" > 
			<xsl:text>#%lblOpen%#</xsl:text> 
		</xsl:when>
		<xsl:otherwise> 
			<xsl:value-of disable-output-escaping="yes" select="." />
		</xsl:otherwise> 
	</xsl:choose> 

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="TCSList">

	<table width="95%">
		<tr>
			<td width="140px"><b>#%lblTCSs%#</b></td>
		</tr>
		<xsl:for-each select="./CmpgnTCSet">
			<tr><td>
				<xsl:if test="string(./@RefUID)">
					<a href="VQANavDoc?QNA=ViewTCS&amp;UID={@RefUID}">
						<xsl:value-of disable-output-escaping="yes" select="./@Title"/>
					</a>
				</xsl:if>
			</td></tr>
		</xsl:for-each>
	</table>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template name="br-replace">

	<xsl:param name="word"/>

	<!-- </xsl:text> on next line on purpose to get newline -->
  <xsl:variable name="cr"><xsl:text>
</xsl:text></xsl:variable>
	<xsl:choose>

		<xsl:when test="contains($word,$cr)">

			<xsl:value-of disable-output-escaping="yes" select="substring-before($word,$cr)"/>
			<br/>
			<xsl:call-template name="br-replace">

				<xsl:with-param name="word">

					<xsl:value-of select="substring-after($word,$cr)"/>
			  </xsl:with-param>
			</xsl:call-template>
		</xsl:when>

		<xsl:otherwise>

			<xsl:value-of disable-output-escaping="yes" select="$word"/>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

</xsl:stylesheet>