<?xml version='1.0'?>
<!-- Stylesheet for a Shipment Document -->

<!DOCTYPE stylesheet [

<!ENTITY nbsp    "&#160;" >
<!ENTITY iexcl   "&#161;" >
<!ENTITY cent    "&#162;" >
<!ENTITY pound   "&#163;" >
<!ENTITY curren  "&#164;" >
<!ENTITY yen     "&#165;" >
<!ENTITY brvbar  "&#166;" >
<!ENTITY sect    "&#167;" >
<!ENTITY uml     "&#168;" >
<!ENTITY copy    "&#169;" >
<!ENTITY ordf    "&#170;" >
<!ENTITY laquo   "&#171;" >
<!ENTITY not     "&#172;" >
<!ENTITY shy     "&#173;" >
<!ENTITY reg     "&#174;" >
<!ENTITY macr    "&#175;" >
<!ENTITY deg     "&#176;" >
<!ENTITY plusmn  "&#177;" >
<!ENTITY sup2    "&#178;" >
<!ENTITY sup3    "&#179;" >
<!ENTITY acute   "&#180;" >
<!ENTITY micro   "&#181;" >
<!ENTITY para    "&#182;" >
<!ENTITY middot  "&#183;" >
<!ENTITY cedil   "&#184;" >
<!ENTITY sup1    "&#185;" >
<!ENTITY ordm    "&#186;" >
<!ENTITY raquo   "&#187;" >
<!ENTITY frac14  "&#188;" >
<!ENTITY frac12  "&#189;" >
<!ENTITY frac34  "&#190;" >
<!ENTITY iquest  "&#191;" >
<!ENTITY Agrave  "&#192;" >
<!ENTITY Aacute  "&#193;" >
<!ENTITY Acirc   "&#194;" >
<!ENTITY Atilde  "&#195;" >
<!ENTITY Auml    "&#196;" >
<!ENTITY Aring   "&#197;" >
<!ENTITY AElig   "&#198;" >
<!ENTITY Ccedil  "&#199;" >
<!ENTITY Egrave  "&#200;" >
<!ENTITY Eacute  "&#201;" >
<!ENTITY Ecirc   "&#202;" >
<!ENTITY Euml    "&#203;" >
<!ENTITY Igrave  "&#204;" >
<!ENTITY Iacute  "&#205;" >
<!ENTITY Icirc   "&#206;" >
<!ENTITY Iuml    "&#207;" >
<!ENTITY ETH     "&#208;" >
<!ENTITY Ntilde  "&#209;" >
<!ENTITY Ograve  "&#210;" >
<!ENTITY Oacute  "&#211;" >
<!ENTITY Ocirc   "&#212;" >
<!ENTITY Otilde  "&#213;" >
<!ENTITY Ouml    "&#214;" >
<!ENTITY times   "&#215;" >
<!ENTITY Oslash  "&#216;" >
<!ENTITY Ugrave  "&#217;" >
<!ENTITY Uacute  "&#218;" >
<!ENTITY Ucirc   "&#219;" >
<!ENTITY Uuml    "&#220;" >
<!ENTITY Yacute  "&#221;" >
<!ENTITY THORN   "&#222;" >
<!ENTITY szlig   "&#223;" >
<!ENTITY agrave  "&#224;" >
<!ENTITY aacute  "&#225;" >
<!ENTITY acirc   "&#226;" >
<!ENTITY atilde  "&#227;" >
<!ENTITY auml    "&#228;" >
<!ENTITY aring   "&#229;" >
<!ENTITY aelig   "&#230;" >
<!ENTITY ccedil  "&#231;" >
<!ENTITY egrave  "&#232;" >
<!ENTITY eacute  "&#233;" >
<!ENTITY ecirc   "&#234;" >
<!ENTITY euml    "&#235;" >
<!ENTITY igrave  "&#236;" >
<!ENTITY iacute  "&#237;" >
<!ENTITY icirc   "&#238;" >
<!ENTITY iuml    "&#239;" >
<!ENTITY eth     "&#240;" >
<!ENTITY ntilde  "&#241;" >
<!ENTITY ograve  "&#242;" >
<!ENTITY oacute  "&#243;" >
<!ENTITY ocirc   "&#244;" >
<!ENTITY otilde  "&#245;" >
<!ENTITY ouml    "&#246;" >
<!ENTITY divide  "&#247;" >
<!ENTITY oslash  "&#248;" >
<!ENTITY ugrave  "&#249;" >
<!ENTITY uacute  "&#250;" >
<!ENTITY ucirc   "&#251;" >
<!ENTITY uuml    "&#252;" >
<!ENTITY yacute  "&#253;" >
<!ENTITY thorn   "&#254;" >
<!ENTITY yuml    "&#255;" >

]>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="html" version="1.0"  indent="yes"/>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="/">

	<html>
	
	<head>

	<title>
		<xsl:text disable-output-escaping="yes">Shipment Document '</xsl:text>
		<xsl:value-of disable-output-escaping="yes" select="ShpDoc/@Appl"/>&#160;<xsl:value-of disable-output-escaping="yes" select="ShpDoc/@ShipRel"/>
		<xsl:text disable-output-escaping="yes">'</xsl:text>
	</title>

	<link rel="stylesheet" type="text/css" href="QNXSLStyle.css"/>
	<link href="favicon.ico" rel="shortcut icon"/>

		<xsl:apply-templates select="ShpDoc/Script"/>
	</head>
	<body bgcolor="#BBBBDD" class="work">

		<xsl:apply-templates select="ShpDoc"/>

		<table width="95%">
			<tr>
				<td colspan="3"><b>Technical Reports</b></td>
			</tr>			
			<tr>
				<td>Ticket</td>
				<td>External ID</td>
				<td>&nbsp;</td>
			</tr>
						
			<xsl:for-each select="ShpDoc">
				<xsl:for-each select="ShpLst">
					<xsl:for-each select="ShpPRRef">
						<tr>
							<td width="80pt">
								<xsl:value-of select="./@Ticket"/>
							</td>
							<td width="110pt">
								<xsl:value-of select="./@ExtID"/>
							</td>
							<td>
								<a href="VQANavDoc?QNA=ViewTR&amp;UID={@RefUID}" ><xsl:value-of disable-output-escaping="yes" select="./@Title"/></a>
							</td>
						</tr>
					</xsl:for-each>
				</xsl:for-each>
			</xsl:for-each>
		</table>

		<table width="95%">
			<tr>
				<td><b>Fix List</b></td>
			</tr>
			<xsl:for-each select="ShpDoc">
				<xsl:for-each select="ShpLst">
					<xsl:for-each select="ShpPRRef">
						<xsl:for-each select="ShpFixRef">
							<tr><td>
								<a href="VQANavDoc?QNA=ViewFix&amp;UID={@RefUID}" >
									<xsl:value-of disable-output-escaping="yes" select="./@Title"/>
								</a>
							</td></tr>
						</xsl:for-each>
					</xsl:for-each>
				</xsl:for-each>
			</xsl:for-each>
		</table>

		<table width="95%">
			<tr>
				<td colspan="8"><b>Changed Files</b></td>
			</tr>

			<tr>				
				<td><b>Date</b></td>
				<td><b>Author</b></td>			
				<td><b>Path</b></td>		
				<td><b>Source File</b></td>
				<td><b>Branch</b></td>			
				<td><b>Version</b></td>			
				<td><b>Section</b></td>
				<!-- td><b>Label</b></td -->
				<!-- td><b>DB</b></td -->
				<td><b>Comment</b></td>				
			</tr>

			<xsl:for-each select="ShpDoc">
				<xsl:for-each select="ShpLst">
					<xsl:for-each select="ShpPRRef">
						<xsl:for-each select="ShpFixRef">
							<xsl:for-each select="ShpFixEntry">

								<tr>	
									<xsl:choose>								
										<xsl:when test="contains( ./@DateTime, 'T' )">
							
											<td><xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/></td>
										</xsl:when>
							
										<xsl:otherwise>
							
											<td><xsl:value-of disable-output-escaping="yes" select="./@DateTime"/></td>
										</xsl:otherwise>
									</xsl:choose>
									
									<td><xsl:value-of disable-output-escaping="yes" select="./@Author"/></td>
									<td><xsl:value-of disable-output-escaping="yes" select="./@Path"/></td>				
									<td><xsl:value-of disable-output-escaping="yes" select="./@Name"/></td>	
									<td><xsl:value-of disable-output-escaping="yes" select="./@Branch"/></td>	
									<td><xsl:value-of disable-output-escaping="yes" select="./@Rel"/></td>
									<td><xsl:value-of disable-output-escaping="yes" select="./@Section"/></td>
									<!-- td><xsl:value-of disable-output-escaping="yes" select="./@Label"/></td -->
									<!-- td><xsl:value-of disable-output-escaping="yes" select="./@SrcSrv"/></td -->
									<td><xsl:value-of disable-output-escaping="yes" select="./@Cmnt"/></td>										
								</tr>
							</xsl:for-each>
						</xsl:for-each>
					</xsl:for-each>
				</xsl:for-each>
			</xsl:for-each>
		</table>
		
		<xsl:if test="./ShpDoc/FileUpload">
	
			<h4 style="margin-left=6px;">Additional Data</h4>
			<table border="2" cellspacing="0" cellpadding="4" width="98%">
				<tr>
					<td valign="center" align="left" colspan="2">
	
						<p>Additional Data</p>
					</td>
				</tr>
				<xsl:apply-templates select="./ShpDoc/FileUpload">
					<xsl:sort select="@DateTime" order="descending"/>
				</xsl:apply-templates>			
			</table>
		</xsl:if>
	
		<xsl:if test="./ShpDoc/LogEntry">
	
			<h4 style="margin-left=6px;">Log Entries</h4>
			<xsl:apply-templates select="./ShpDoc/LogEntry">
				<xsl:sort select="@DateTime" order="descending"/>
			</xsl:apply-templates>
		</xsl:if>
	
		<xsl:if test="./ShpDoc/ProcLog">
	
			<h4 style="margin-left=6px;">Process Log</h4>
				<table width="98%">
					<tr><td class="DT"><b>Date</b></td><td>&#160;</td></tr>
					<xsl:apply-templates select="./ShpDoc/ProcLog">
						<xsl:sort select="@DateTime" order="descending"/>
					</xsl:apply-templates>
				</table>
		</xsl:if>		
	</body>

	</html>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="Script">
	<script type="text/javascript">
	<xsl:value-of disable-output-escaping="yes" select="text()"/>
	</script>
</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="ShpDoc">

	<h2 style="margin-left=6px;">Shipment Document</h2>

	<table width="95%">
		<tr>
			<td><b><xsl:value-of disable-output-escaping="yes" select="./@Appl"/>&#160;<xsl:value-of disable-output-escaping="yes" select="./@ShipRel"/></b></td>
		</tr>
		<tr>
			<td>
				<xsl:value-of select="./@Cmnt"/>
			</td>
		</tr>
	</table>

	<table>
		<tr>
			<td width="120px"><b>UID</b></td>
			<td><xsl:value-of select="./@UID" /></td>
		</tr>
	</table>

	<table>
		<tr>
			<td width="120px"><b>Author</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@Author" /></td>
		</tr>
		<tr>
			<td width="120px"><b>Date</b></td>
			<td><xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/></td>
		</tr>
		<tr>
			<td width="120px"><b>Ship Date</b></td>
			<td><xsl:apply-templates select="./@DateTimeShip"/></td>
		</tr>
	</table>

	<xsl:if test="string(./@Lock)">
		<table><tr><td width="30"><img src="rsc/PadLock.jpg" alt="Locked"/></td></tr></table>
	</xsl:if>

	<table>
		<tr><td width="120px"><b>Status</b></td><td>
			<xsl:apply-templates select="./@ShipStat"/>
		</td></tr>
		<tr><td width="120px"><b>Assigned To</b></td><td>
			<xsl:value-of disable-output-escaping="yes" select="./@Assignd"/>
		</td></tr>
		<tr><td width="120px"><b>Test System</b></td><td>
			<xsl:value-of disable-output-escaping="yes" select="./@TstSys"/>
		</td></tr>		
	</table>
	
	<h4 style="margin-left=6px;">Shipment List</h4>

	<xsl:apply-templates select="./ShpLst"/>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="ShpLst">

	<table width="95%">
		<tr>
			<td>	
				<xsl:apply-templates select="./ShpPRRef"/>
			</td>
		</tr>
	</table>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="ShpPRRef">

	<table width="100%">
		<tr>
			<td>Technical Report&#160;<xsl:value-of select="./@Ticket"/>&#160;<a href="VQANavDoc?QNA=ViewTR&amp;UID={@RefUID}" >
					<xsl:value-of disable-output-escaping="yes" select="./@Title"/>
				</a>
			</td>
		</tr>
		<tr>
			<td>
				<xsl:apply-templates select="./ShpFixRef"/>
			</td>
		</tr>

	</table>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="ShpFixRef">

	<table width="100%">

		<tr>
			<td>Fix 				
				<a href="VQANavDoc?QNA=ViewFix&amp;UID={@RefUID}" >
					<xsl:value-of disable-output-escaping="yes" select="./@Title"/>
				</a>
			</td>
		</tr>

		<xsl:if test="string(./ShpFixEntry/@Name)">
			<tr>
				<td>
					<table>
						<tr>
							<td><b>Date</b></td>
							<td><b>Author</b></td>			
							<td><b>Path</b></td>		
							<td><b>Source File</b></td>
							<td><b>Branch</b></td>			
							<td><b>Version</b></td>			
							<td><b>Section</b></td>
							<!-- td><b>Label</b></td -->
							<!-- td><b>DB</b></td -->
							<td><b>Comment</b></td>							
						</tr>
						<xsl:apply-templates select="./ShpFixEntry"/>
						</table>
				</td>
			</tr>
		</xsl:if>
	</table>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="ShpFixEntry">

	<tr>
		<xsl:choose>

			<xsl:when test="contains( ./@DateTime, 'T' )">

				<td><xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/></td>
			</xsl:when>

			<xsl:otherwise>

				<td><xsl:value-of disable-output-escaping="yes" select="./@DateTime"/></td>
			</xsl:otherwise>
		</xsl:choose>
		
		<td><xsl:value-of disable-output-escaping="yes" select="./@Author"/></td>
		<td><xsl:value-of disable-output-escaping="yes" select="./@Path"/></td>				
		<td><xsl:value-of disable-output-escaping="yes" select="./@Name"/></td>	
		<td><xsl:value-of disable-output-escaping="yes" select="./@Branch"/></td>	
		<td><xsl:value-of disable-output-escaping="yes" select="./@Rel"/></td>
		<td><xsl:value-of disable-output-escaping="yes" select="./@Section"/></td>
		<!-- td><xsl:value-of disable-output-escaping="yes" select="./@Label"/></td -->
		<!-- td><xsl:value-of disable-output-escaping="yes" select="./@SrcSrv"/></td -->
		<td><xsl:value-of disable-output-escaping="yes" select="./@Cmnt"/></td>		
	</tr>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="@ShipStat">

	<xsl:choose > 
<xsl:when test = ". = 'beta'" ><xsl:text>Beta</xsl:text></xsl:when>
<xsl:when test = ". = 'rDpl'" ><xsl:text>Ready for Deployment</xsl:text></xsl:when>
<xsl:when test = ". = 'rProd'" ><xsl:text>Ready for Production</xsl:text></xsl:when>
<xsl:when test = ". = 'prod'" ><xsl:text>In Production</xsl:text></xsl:when>
<xsl:when test = ". = 'rSysTst'" ><xsl:text>Ready for System Test</xsl:text></xsl:when>
<xsl:when test = ". = 'sysTst'" ><xsl:text>System Test</xsl:text></xsl:when>
<xsl:when test = ". = 'rj'" ><xsl:text>Rejected</xsl:text></xsl:when>
<xsl:when test = ". = 'new'" ><xsl:text>New</xsl:text></xsl:when>
		<xsl:otherwise> 
			<xsl:value-of disable-output-escaping="yes" select="." />
		</xsl:otherwise> 
	</xsl:choose> 

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="FileUpload">

	<tr><td>
		<table border="1" cellspacing="0" cellpadding="4">
			<tr>
				<td class="DT"><xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/></td>
				<td width="80px"><xsl:value-of disable-output-escaping="yes" select="./@Author"/></td>
				<td valign="center" align="left" width="550pt">
					<xsl:value-of disable-output-escaping="yes" select="./Desc"/>&#160;
					<a href="Upload/{@UID}/{@TName}" type="{@ContentType}" target="_blank"><xsl:value-of disable-output-escaping="yes" select="./@Name"/></a>

				</td>
			</tr>
		</table>
	</td></tr>
</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="LogEntry">

	<table width="98%">
		<tr>
			<td class="DT" rowspan="2"><xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/></td>
			<td width="160px">Author: <xsl:value-of disable-output-escaping="yes" select="./@Author"/></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@Title"/></td>
		</tr>
		<tr>
			<td colspan="2">
				<p>
					<xsl:call-template name="br-replace">
						<xsl:with-param name="word" select="."/>
					</xsl:call-template>
				</p>
			</td>
		</tr>
	</table>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="ProcLog">

		<tr>
			<td class="DT"><xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/></td>
			<td><p><xsl:value-of disable-output-escaping="yes" select="."/></p></td>
		</tr>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template name="br-replace">

	<xsl:param name="word"/>

	<!-- </xsl:text> on next line on purpose to get newline -->
  <xsl:variable name="cr"><xsl:text>
</xsl:text></xsl:variable>

	<xsl:choose>

		<xsl:when test="contains($word,$cr)">

			<xsl:value-of disable-output-escaping="yes" select="substring-before($word,$cr)"/>
			<br/>
			<xsl:call-template name="br-replace">

				<xsl:with-param name="word">

					<xsl:value-of select="substring-after($word,$cr)"/>
			  </xsl:with-param>
			</xsl:call-template>
		</xsl:when>

		<xsl:otherwise>

			<xsl:value-of disable-output-escaping="yes" select="$word"/>
		</xsl:otherwise>
	</xsl:choose>

</xsl:template>

</xsl:stylesheet>
 
